hwy::Image< ComponentType > Class Template Reference

`#include <image.h>`

Inheritance diagram for hwy::Image< ComponentType >:

## Public Types

using | T = ComponentType

## Public Member Functions

| Image ()=default
| Image (const size_t xsize, const size_t ysize)
| Image (const size_t xsize, const size_t ysize, size_t bytes_per_row, void *aligned)
void | InitializePaddingForUnalignedAccesses ()
HWY_INLINE const T * | ConstRow (const size_t y) const
HWY_INLINE const T * | ConstRow (const size_t y)
HWY_INLINE T * | MutableRow (const size_t y) const
HWY_INLINE T * | MutableRow (const size_t y)
HWY_INLINE intptr_t | PixelsPerRow () const
Public Member Functions inherited from hwy::ImageBase
| ImageBase ()
| ImageBase (size_t xsize, size_t ysize, size_t sizeof_t)
| ImageBase (size_t xsize, size_t ysize, size_t bytes_per_row, void *aligned)
| ImageBase (const ImageBase &other)=delete
ImageBase & | operator= (const ImageBase &other)=delete
| ImageBase (ImageBase &&other) noexcept=default
ImageBase & | operator= (ImageBase &&other) noexcept=default
void | Swap (ImageBase &other)
void | ShrinkTo (const size_t xsize, const size_t ysize)
HWY_INLINE size_t | xsize () const
HWY_INLINE size_t | ysize () const
HWY_INLINE size_t | bytes_per_row () const
HWY_INLINE uint8_t * | bytes ()
HWY_INLINE const uint8_t * | bytes () const

## Additional Inherited Members

Static Public Member Functions inherited from hwy::ImageBase
static size_t | VectorSize ()
static size_t | BytesPerRow (const size_t xsize, const size_t sizeof_t)
Protected Types inherited from hwy::ImageBase
enum class | Padding { kRoundUp , kUnaligned }
Protected Member Functions inherited from hwy::ImageBase
HWY_INLINE void * | VoidRow (const size_t y) const
void | InitializePadding (size_t sizeof_t, Padding padding)
Protected Attributes inherited from hwy::ImageBase
uint32_t | xsize_
uint32_t | ysize_
size_t | bytes_per_row_
AlignedFreeUniquePtr< uint8_t[]> | bytes_

## Member Typedef Documentation

## T

template<typename ComponentType >

using hwy::Image< ComponentType >::T = ComponentType

## Constructor & Destructor Documentation

## Image() [1/3]

template<typename ComponentType >

hwy::Image< ComponentType >::Image | ( |  | ) |

default

## Image() [2/3]

template<typename ComponentType >

hwy::Image< ComponentType >::Image | ( | const size_t | xsize,
|  | const size_t | ysize
| ) |  |

inline

## Image() [3/3]

template<typename ComponentType >

hwy::Image< ComponentType >::Image | ( | const size_t | xsize,
|  | const size_t | ysize,
|  | size_t | bytes_per_row,
|  | void * | aligned
| ) |  |

inline

## Member Function Documentation

## ConstRow() [1/2]

template<typename ComponentType >

HWY_INLINE const T * hwy::Image< ComponentType >::ConstRow | ( | const size_t | y | ) |

inline

References hwy::ImageBase::VoidRow().

## ConstRow() [2/2]

template<typename ComponentType >

HWY_INLINE const T * hwy::Image< ComponentType >::ConstRow | ( | const size_t | y | ) | const

inline

References hwy::ImageBase::VoidRow().

Referenced by hwy::Rect::ConstRow().

## InitializePaddingForUnalignedAccesses()

template<typename ComponentType >

void hwy::Image< ComponentType >::InitializePaddingForUnalignedAccesses | ( |  | ) |

inline

References hwy::ImageBase::InitializePadding(), and hwy::ImageBase::kUnaligned.

## MutableRow() [1/2]

template<typename ComponentType >

HWY_INLINE T * hwy::Image< ComponentType >::MutableRow | ( | const size_t | y | ) |

inline

References hwy::ImageBase::VoidRow().

## MutableRow() [2/2]

template<typename ComponentType >

HWY_INLINE T * hwy::Image< ComponentType >::MutableRow | ( | const size_t | y | ) | const

inline

References hwy::ImageBase::VoidRow().

Referenced by hwy::Rect::MutableRow().

## PixelsPerRow()

template<typename ComponentType >

HWY_INLINE intptr_t hwy::Image< ComponentType >::PixelsPerRow | ( |  | ) | const

inline

References hwy::ImageBase::bytes_per_row_.

Referenced by hwy::Image3< ComponentType >::PixelsPerRow().

The documentation for this class was generated from the following file:

- image.h